ompi/class/ompi_rb_tree.h File Reference.TH "ompi/class/ompi_rb_tree.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/class/ompi_rb_tree.h \- A red black tree. 
.SH SYNOPSIS
.br
.PP
\fC#include <stdlib.h>\fP
.br
\fC#include 'ompi/include/constants.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br
\fC#include 'class/ompi_free_list.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBompi_rb_tree_node_t\fP \fBompi_rb_tree_node_t\fP"
.br
.ti -1c
.RI "typedef int(* \fBompi_rb_tree_comp_fn_t\fP )(void *key1, void *key2)"
.br
.RI "\fIthe compare function typedef. \fP"
.ti -1c
.RI "typedef \fBompi_rb_tree_t\fP \fBompi_rb_tree_t\fP"
.br
.ti -1c
.RI "typedef int(* \fBompi_rb_tree_condition_fn_t\fP )(void *)"
.br
.RI "\fIthis function is used for the ompi_rb_tree_traverse function. \fP"
.ti -1c
.RI "typedef void(* \fBompi_rb_tree_action_fn_t\fP )(void *, void *)"
.br
.RI "\fIthis function is uused for the user to perform any action on the passed values. \fP"
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum \fBompi_rb_tree_nodecolor_t\fP { \fBRED\fP, \fBBLACK\fP }"
.br
.RI "\fIred and black enum \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (\fBompi_rb_tree_node_t\fP)"
.br
.RI "\fIdeclare the tree node as a class \fP"
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (\fBompi_rb_tree_t\fP)"
.br
.RI "\fIdeclare the tree as a class \fP"
.ti -1c
.RI "OMPI_DECLSPEC void \fBompi_rb_tree_construct\fP (\fBopal_object_t\fP *object)"
.br
.RI "\fIthe construct function. \fP"
.ti -1c
.RI "OMPI_DECLSPEC void \fBompi_rb_tree_destruct\fP (\fBopal_object_t\fP *object)"
.br
.RI "\fIthe destruct function. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_rb_tree_init\fP (\fBompi_rb_tree_t\fP *tree, \fBompi_rb_tree_comp_fn_t\fP comp)"
.br
.RI "\fIthe function creates a new tree \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_rb_tree_insert\fP (\fBompi_rb_tree_t\fP *tree, void *key, void *value)"
.br
.RI "\fIinserts a node into the tree \fP"
.ti -1c
.RI "OMPI_DECLSPEC void * \fBompi_rb_tree_find\fP (\fBompi_rb_tree_t\fP *tree, void *key)"
.br
.RI "\fIfinds a value in the tree based on the passed key \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_rb_tree_delete\fP (\fBompi_rb_tree_t\fP *tree, void *key)"
.br
.RI "\fIdeletes a node based on its key \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_rb_tree_destroy\fP (\fBompi_rb_tree_t\fP *tree)"
.br
.RI "\fIfrees all the nodes on the tree \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_rb_tree_traverse\fP (\fBompi_rb_tree_t\fP *tree, \fBompi_rb_tree_condition_fn_t\fP cond, \fBompi_rb_tree_action_fn_t\fP action)"
.br
.RI "\fItraverses the entire tree, performing the cond function on each of the values and if it returns one it performs the action function on the values \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_rb_tree_size\fP (\fBompi_rb_tree_t\fP *tree)"
.br
.RI "\fIreturns the size of the tree \fP"
.in -1c
.SH "Detailed Description"
.PP 
A red black tree. 


.SH "Typedef Documentation"
.PP 
.SS "typedef void(* \fBompi_rb_tree_action_fn_t\fP)(void *, void *)"
.PP
this function is uused for the user to perform any action on the passed values. 
.PP
The first argument is the key and the second is the value. note that this function SHOULD NOT modify the keys, as that would mess up the tree. 
.SS "typedef int(* \fBompi_rb_tree_comp_fn_t\fP)(void *key1, void *key2)"
.PP
the compare function typedef. 
.PP
This function is used to compare 2 nodes. 
.SS "typedef int(* \fBompi_rb_tree_condition_fn_t\fP)(void *)"
.PP
this function is used for the ompi_rb_tree_traverse function. 
.PP
it is passed a pointer to the value for each node and, if it returns a one, the action function is called on that node. Otherwise, the node is ignored. 
.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC void ompi_rb_tree_construct (\fBopal_object_t\fP * object)"
.PP
the construct function. 
.PP
creates the free list to get the nodes from
.PP
\fBParameters:\fP
.RS 4
\fIobject\fP the tree that is to be used
.RE
.PP
\fBReturn values:\fP
.RS 4
\fINONE\fP .RE
.PP

.SS "OMPI_DECLSPEC int ompi_rb_tree_delete (\fBompi_rb_tree_t\fP * tree, void * key)"
.PP
deletes a node based on its key 
.PP
\fBParameters:\fP
.RS 4
\fItree\fP a pointer to the tree data structure 
.br
\fIkey\fP a pointer to the key
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP if the node is found and deleted 
.br
\fIOMPI_ERR_NOT_FOUND\fP if the node is not found 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_rb_tree_destroy (\fBompi_rb_tree_t\fP * tree)"
.PP
frees all the nodes on the tree 
.PP
\fBParameters:\fP
.RS 4
\fItree\fP a pointer to the tree data structure
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP .RE
.PP

.SS "OMPI_DECLSPEC void ompi_rb_tree_destruct (\fBopal_object_t\fP * object)"
.PP
the destruct function. 
.PP
tries to free the tree and destroys the free list
.PP
\fBParameters:\fP
.RS 4
\fIobject\fP the tree object 
.RE
.PP

.SS "OMPI_DECLSPEC void* ompi_rb_tree_find (\fBompi_rb_tree_t\fP * tree, void * key)"
.PP
finds a value in the tree based on the passed key 
.PP
\fBParameters:\fP
.RS 4
\fItree\fP a pointer to the tree data structure 
.br
\fIkey\fP a pointer to the key
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIpointer\fP to the value if found 
.br
\fINULL\fP if not found 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_rb_tree_init (\fBompi_rb_tree_t\fP * tree, \fBompi_rb_tree_comp_fn_t\fP comp)"
.PP
the function creates a new tree 
.PP
\fBParameters:\fP
.RS 4
\fItree\fP a pointer to an allocated area of memory for the main tree data structure. 
.br
\fIcomp\fP a pointer to the function to use for comaparing 2 nodes
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP if it is successful 
.br
\fIOMPI_ERR_TEMP_OUT_OF_RESOURCE\fP if unsuccessful 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_rb_tree_insert (\fBompi_rb_tree_t\fP * tree, void * key, void * value)"
.PP
inserts a node into the tree 
.PP
\fBParameters:\fP
.RS 4
\fItree\fP a pointer to the tree data structure 
.br
\fIkey\fP the key for the node 
.br
\fIvalue\fP the value for the node
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP .br
\fIOMPI_ERR_TEMP_OUT_OF_RESOURCE\fP if unsuccessful 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_rb_tree_size (\fBompi_rb_tree_t\fP * tree)"
.PP
returns the size of the tree 
.PP
\fBParameters:\fP
.RS 4
\fItree\fP a pointer to the tree data structure
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIint\fP the nuber of items on the tree 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_rb_tree_traverse (\fBompi_rb_tree_t\fP * tree, \fBompi_rb_tree_condition_fn_t\fP cond, \fBompi_rb_tree_action_fn_t\fP action)"
.PP
traverses the entire tree, performing the cond function on each of the values and if it returns one it performs the action function on the values 
.PP
\fBParameters:\fP
.RS 4
\fItree\fP a pointer to the tree 
.br
\fIcond\fP a pointer to the condition function 
.br
\fIaction\fP a pointer to the action function
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP .br
\fIOMPI_ERROR\fP if there is an error 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
